"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var combine_fragments_exports = {};
__export(combine_fragments_exports, {
  combineFragments: () => combineFragments
});
module.exports = __toCommonJS(combine_fragments_exports);
function combineFragments(...fragments) {
  if (fragments.length === 0) {
    return {
      Resources: {}
    };
  }
  return fragments.reduce((acc, next) => ({
    Conditions: { ...acc.Conditions, ...next.Conditions },
    Globals: {
      ...acc.Globals,
      ...next.Globals,
      Function: {
        ...acc.Globals?.Function,
        ...next.Globals?.Function,
        Environment: {
          // @ts-expect-error - typedef treats `Environment` as `unknown`
          ...acc.Globals?.Function?.Environment,
          // @ts-expect-error - typedef treats `Environment` as `unknown`
          ...next.Globals?.Function?.Environment,
          Variables: {
            // @ts-expect-error - typedef treats `Environment` as `unknown`
            ...acc.Globals?.Function?.Environment?.Variables,
            // @ts-expect-error - typedef treats `Environment` as `unknown`
            ...next.Globals?.Function?.Environment?.Variables
          }
        }
      }
    },
    Outputs: { ...acc.Outputs, ...next.Outputs },
    Parameters: { ...acc.Parameters, ...next.Parameters },
    Resources: { ...acc.Resources, ...next.Resources }
  }));
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  combineFragments
});
