import { combineFragments } from "../fragments/combine-fragments";
import { makeHandler } from "./lambdas";
function defineEnricher(config, model, cdc) {
  const {
    actionsModuleId,
    handlerImportName,
    handlerModuleId,
    runtimeModuleId,
    sourceModelName,
    targetModelName
  } = cdc;
  const template = `// This file is generated. Do not edit by hand.
import {expandTableNames,makeEnricher} from '${runtimeModuleId}';
import {${handlerImportName}} from '${handlerModuleId}';
import {
  ${sourceModelName},
  ${targetModelName},
  create${targetModelName},
  unmarshall${sourceModelName},
  update${targetModelName},
  Create${targetModelName}Input,
  Update${targetModelName}Input
} from '${actionsModuleId}';

expandTableNames();

export const handler = makeEnricher<
${sourceModelName},
${targetModelName},
Create${targetModelName}Input,
Update${targetModelName}Input
>(
  ${handlerImportName},
  {
    createTargetModel: create${targetModelName},
    unmarshallSourceModel: unmarshall${sourceModelName},
    updateTargetModel: update${targetModelName}
  }
);
`;
  return combineFragments(makeHandler(config, model, cdc, template));
}
export {
  defineEnricher
};
