import { combineFragments } from "../fragments/combine-fragments";
import { makeHandler } from "./lambdas";
function defineReactor(config, model, cdc) {
  const {
    actionsModuleId,
    handlerImportName,
    handlerModuleId,
    runtimeModuleId,
    sourceModelName
  } = cdc;
  const code = `// This file is generated. Do not edit by hand.
import {expandTableNames, makeReactor} from '${runtimeModuleId}';
import {${handlerImportName}} from '${handlerModuleId}';
import type {${sourceModelName}, unmarshall${sourceModelName}} from '${actionsModuleId}';

expandTableNames();

export const handler = makeReactor<${sourceModelName}>(${handlerImportName}, {unmarshallSourceModel: unmarshall${sourceModelName}});
`;
  return combineFragments(makeHandler(config, model, cdc, code));
}
export {
  defineReactor
};
