function makeLogGroup({
  functionName
}) {
  const logGroup = {
    Properties: {
      // @ts-expect-error typedef doesn't include intrinsic functions
      LogGroupName: { "Fn::Sub": `/aws/lambda/\${${functionName}}` },
      // @ts-expect-error typedef doesn't include intrinsic functions
      RetentionInDays: { Ref: "LogRetentionInDays" }
    },
    Type: "AWS::Logs::LogGroup"
  };
  return {
    Parameters: {
      LogRetentionInDays: {
        Default: "3",
        Description: "Log retention in days",
        Type: "Number"
      }
    },
    Resources: {
      [`${functionName}LogGroup`]: logGroup
    }
  };
}
export {
  makeLogGroup
};
